//---------------------------------------------------------------------------

#ifndef apuH
#define apuH

#include "types.h"

class Capu
	{
	public:
		u32 cycle;
		u8 regs[32];					//backup of registers
		u8 *soundbuf;
		u32 soundbufsize;
		u8 square_table[32];
		u8 tnd_table[256];
		u8 f_sequencerpos;			//position of sequencer for frame sequencer
		u8 t_step;						//triangle step generator
		u32 t_linearcounter;			//linear counter
		u32 t_timer;					//programmable timer
		u8 t_lengthcounter;			//length counter
		u8 t_haltlinear;				//halt linear counter flag
		u8 t_sequencerpos;			//current seqencer output
		u8 t_output;					//output for this cycle
		u8 s1_output;
		u8 s2_output;
		u8 n_output;
		u8 d_output;
   public:
		virtual void ClockTriangleSequencer();
		virtual void ClockTriangleLinearCounter();
		virtual void ClockTriangleLengthCounter();
		virtual void ClockTriangleTimer();
		virtual void ClockFrameCounter();
		virtual void FillSamples(int n);
		Capu();
		void Reset();
		void Step();
		u8 Read(u32 addr);
		void Write(u32 addr,u8 data);
   };

//---------------------------------------------------------------------------
#endif
