class CMapper105:public CMMC1
	{
	public:
		int switches[4];
		u64 Counter;
		int CounterEnable,State;
		int PPUCycle;
	public:
		CMapper105()
			{
			number = 105;
			message("NES-EVENT mapper loaded\n");
			}
		void Reset()
			{
			CMMC1::Reset();
			State = 0;
			Counter = 0;
			CounterEnable = 0;
			PPUCycle = 0;
			Sync();
			}
		void Cycle(int pixel)
			{
			PPUCycle++;
			if(PPUCycle == 3)
				{
				if(CounterEnable)
					{
					Counter++;
					if(Counter == 0x3E000000)
						{
						nes.cpu->IRQ();
						CounterEnable = 0;
						}
					}
				PPUCycle = 0;
				}
			}
		void Sync()
			{
			int n = GetLowCHR();

			SyncVRAM();
			SyncMirroring();
			switch(State)
				{
				case 0:
					if(n & 0x10)
						State++;
					break;
				case 1:
					if(~n & 0x10)
						State++;
					break;
				case 2:
					if(n & 8)
						SyncPRG();
					else
						nes.SetPageCPU32(8,(n >> 1) & 3);
					if(n & 0x10)
						{
						CounterEnable = 0;
						Counter = 0;
						}
					else
						CounterEnable = 1;
					return;
				}
			nes.SetPageCPU32(8,0);
			}
		void Write(u32 addr,u8 data)
			{
			CMMC1::Write(addr,data);
			}
	};
