class CMapper19:public CMapper
	{
	public:
		u8 PRGBank[4];
		u8 CHRBank[8];
		u8 NTBank[4];
	public:
		CMapper19()
			{
			number = 19;
			message("Namcot 106 mapper loaded\n");
			}
		void Reset()
			{
			int i;
			
			SetWriteHandled(0x5,0x5);
			SetWriteHandled(0x8,0xF);
			for(i=0;i<8;i++)
				PRGBank[i & 3] = CHRBank[i] = NTBank[i & 3] = 0xFF;
			Sync();
			}
		void Sync()
			{
			int i;
			
			nes.SetPageCPU8(0x8,PRGBank[0]);
			nes.SetPageCPU8(0xA,PRGBank[1]);
			nes.SetPageCPU8(0xC,PRGBank[2]);
			nes.SetPageCPU8(0xE,PRGBank[3]);
			for(i=0;i<4;i++)
				{
				if(PRGBank[1] & 0x40)		//chrrom only
					nes.SetPagePPU1(i,CHRBank[i]);
				else								//chrrom + chrram
					{
					if(CHRBank[i] >= 0xE0)	//map chrram
						nes.SetPageVRAM1(i,CHRBank[i] & 0x3F);
					else
						nes.SetPagePPU1(i,CHRBank[i]);
					}
				}
			for(i=4;i<8;i++)
				{
				if(PRGBank[1] & 0x80)		//chrrom only
					nes.SetPagePPU1(i,CHRBank[i]);
				else								//chrrom + chrram
					{
					if(CHRBank[i] >= 0xE0)	//map chrram
						nes.SetPageVRAM1(i,CHRBank[i] & 0x3F);
					else
						nes.SetPagePPU1(i,CHRBank[i]);
					}
				}
			}
		void Write(u32 addr,u8 data)
			{
			switch(addr & 0xF800)
				{
				case 0x5000:	break;
				case 0x5800:	break;
				case 0x8000:	CHRBank[0] = data;	break;
				case 0x8800:	CHRBank[1] = data;	break;
				case 0x9000:	CHRBank[2] = data;	break;
				case 0x9800:	CHRBank[3] = data;	break;
				case 0xA000:	CHRBank[4] = data;	break;
				case 0xA800:	CHRBank[5] = data;	break;
				case 0xB000:	CHRBank[6] = data;	break;
				case 0xB800:	CHRBank[7] = data;	break;
				case 0xC000:	NTBank[0] = data;		break;
				case 0xC800:	NTBank[1] = data;		break;
				case 0xD000:	NTBank[2] = data;		break;
				case 0xD800:	NTBank[3] = data;		break;
				case 0xE000:	PRGBank[0] = data;	break;
				case 0xE800:	PRGBank[0] = data;	break;
				case 0xF000:	PRGBank[0] = data;	break;
				}
			Sync();
			}
	};
