class CMapper40:public CMapper
	{
	protected:
		u64 m2;
		int irqenable;
	public:
		CMapper40()
			{
			number = 40;
			message("SMB2j mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0x8,0xF);
			nes.ppu->cycle = MapperCycle;
			m2 = 0;
			irqenable = 0;
			nes.SetPageCPU8(0x6,6);
			nes.SetPageCPU8(0x8,4);
			nes.SetPageCPU8(0xA,5);
			nes.SetPageCPU8(0xC,0);
			nes.SetPageCPU8(0xE,7);
			nes.SetPagePPU8(0,0);
			}
		void Cycle(int pixel)
			{
			if(irqenable == 0)
				return;
			m2++;
			if(m2 >= (4096*3))			//generate irq
				{
				nes.cpu->IRQ();
				m2 -= 4096*3;
				}
			}
		void Write(u32 addr,u8 data)
			{
			switch(addr & 0xE000)
				{
				case 0x8000: //disable and reset irq counter
					m2 = 0;
					irqenable = 0;
					break;
				case 0xA000: //enable irq counter
					irqenable = 1;
					break;
				case 0xE000: //select 8k prg bank (3 bits)
					nes.SetPageCPU8(0xC,data & 7);
					break;
				}
			}
	};
