class CMapper42:public CMapper
	{
	protected:
		u64 m2;
		int irqenable;
	public:
		CMapper42()
			{
			number = 42;
			message("42 mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0xC,0xF);
			nes.ppu->cycle = MapperCycle;
			m2 = 0;
			irqenable = 0;
			nes.SetPageCPU8(0x6,0);
			nes.SetPageCPU8(0x8,0xC);
			nes.SetPageCPU8(0xA,0xD);
			nes.SetPageCPU8(0xC,0xE);
			nes.SetPageCPU8(0xE,0xF);
			nes.SetSizeVRAM(8);
			}
		void Cycle(int pixel)	//ppu cycle
			{
			if(irqenable == 0)
				return;
			m2++;
			if(m2 >= (24576*3))			//generate irq
				{
				nes.cpu->IRQ();
				m2 -= 24576*3;
				}
			}
		void Write(u32 addr,u8 data)
			{
			switch(addr & 3)
				{
				case 2: //enable irq counter
					if(data & 2)
						irqenable = 1;
					else
						{
						m2 = 0;
						irqenable = 0;
						}
					break;
				case 1: //mirror control
					nes.ppu->SetMirroring((~data >> 3) & 1);
					break;
				case 0: //select 8k prg bank (3 bits)
					nes.SetPageCPU8(6,data & 0xF);
					break;
				}
			}
	};
