class CMapper50:public CMapper
	{
	protected:
		int IRQEnabled,IRQCounter;
	public:
		CMapper50()
			{
			number = 50;
			message("SMB2j Revision 'A' mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0x4,0x5);
			nes.ppu->cycle = MapperCycle;
			IRQEnabled = IRQCounter = 0;
			nes.SetPageCPU8(0x6,0xF);
			nes.SetPageCPU8(0x8,0x8);
			nes.SetPageCPU8(0xA,0x9);
			nes.SetPageCPU8(0xC,0);
			nes.SetPageCPU8(0xE,0xB);
			nes.SetSizeVRAM(8);
			nes.SetPageVRAM8(0,0);
			}
		void Cycle(int pixel)
			{
			if(IRQEnabled)
				{
				IRQCounter++;
				if(IRQCounter >= 4096*3)
					nes.cpu->IRQ();
				}
			}
		void Write(u32 addr,u8 data)
			{
			if((addr & 0x60) != 0x20)
				return;
			if((addr & 0x100) == 0)
				nes.SetPageCPU8(0xC,((data & 1) << 2) | ((data & 6) >> 1) | (data & 8));
			else
				{
				if(data & 1)
					IRQEnabled = 1;
				else
					{
					IRQCounter = 0;
					IRQEnabled = 0;
					}
				}
			}
	};
