static u8 Mapper9_Read3(u32 addr);
static u8 Mapper9_Read7(u32 addr);

class CMapper9:public CMapper
	{
	public:
		int PRGBank,Mirroring;
		int LatchA[2],LatchAState;
		int LatchB[2],LatchBState;
	public:
		CMapper9()
			{
			number = 9;
			message("MMC2 mapper loaded\n");
			}
		void Reset()
			{
			SetWriteHandled(0xA,0xF);
			nes.ppu->readfunc[3] = Mapper9_Read3;
			nes.ppu->readfunc[7] = Mapper9_Read7;
			LatchA[0] = LatchA[1] = 0;
			LatchB[0] = LatchB[1] = 0;
			LatchAState = LatchBState = 0;
			PRGBank = 0;
			Mirroring = 0;
			Sync();
			}
		void Sync()
			{
			nes.SetPageCPU8(0x8,PRGBank);
			nes.SetPageCPU8(0xA,0xD);
			nes.SetPageCPU8(0xC,0xE);
			nes.SetPageCPU8(0xE,0xF);
			nes.SetPagePPU4(0,LatchA[LatchAState]);
			nes.SetPagePPU4(4,LatchB[LatchAState]);
			nes.ppu->SetMirroring(Mirroring);
			}
		void Write(u32 addr,u8 data)
			{
			switch(addr & 0xF000)
				{
				case 0xA000:
					PRGBank = data & 0xF;
					break;
				case 0xB000:
					LatchA[0] = data & 0x1F;
					break;
				case 0xC000:
					LatchA[1] = data & 0x1F;
					break;
				case 0xD000:
					LatchB[0] = data & 0x1F;
					break;
				case 0xE000:
					LatchB[1] = data & 0x1F;
					break;
				case 0xF000:
					Mirroring = data & 1;
					break;
				}
			Sync();
			}
	};

static u8 Mapper9_Read3(u32 addr)
{
CMapper9 *m = (CMapper9*)mapper;
u8 ret = nes.ppu->readptr[3][addr & 0x3FF];

switch(addr & 0x3F8)
	{
	case 0x3D8:
		m->LatchAState = 0;
		nes.SetPagePPU4(0,m->LatchA[0]);
		break;
	case 0x3E8:
		m->LatchAState = 1;
		nes.SetPagePPU4(0,m->LatchA[1]);
		break;
	}
return(ret);
}

static u8 Mapper9_Read7(u32 addr)
{
CMapper9 *m = (CMapper9*)mapper;
u8 ret = nes.ppu->readptr[7][addr & 0x3FF];

switch(addr & 0x3F8)
	{
	case 0x3D8:
		m->LatchBState = 0;
		nes.SetPagePPU4(4,m->LatchB[0]);
		break;
	case 0x3E8:
		m->LatchBState = 1;
		nes.SetPagePPU4(4,m->LatchB[1]);
		break;
	}
return(ret);
}
