#include "main.h"
#include "mappers.h"

extern u32 mask;

CMapper *mapper = 0;

void SetWriteHandled(u32 pagestart,u32 pageend)
{
pagestart <<= 1;
pageend <<= 1;
pageend |= 1;
for(;pagestart<=pageend;pagestart++)
	nes.cpu->writeptr[pagestart] = MapperWrite;
}

#include "mapper_mmc1.cpp"
#include "mapper_mmc3.cpp"

#include "mapper0.cpp"
#include "mapper1.cpp"
#include "mapper2.cpp"
#include "mapper3.cpp"
#include "mapper4.cpp"
#include "mapper7.cpp"
#include "mapper9.cpp"
#include "mapper15.cpp"
#include "mapper19.cpp"
#include "mapper34.cpp"
#include "mapper40.cpp"
#include "mapper41.cpp"
#include "mapper42.cpp"
#include "mapper44.cpp"
#include "mapper45.cpp"
#include "mapper47.cpp"
#include "mapper50.cpp"
#include "mapper61.cpp"
#include "mapper66.cpp"
#include "mapper71.cpp"
#include "mapper79.cpp"
#include "mapper105.cpp"
#include "mapper113.cpp"
#include "mapper232.cpp"
#include "mapper234.cpp"

void MapperReset()
{
mapper->Reset();
}

void MapperWrite(u32 addr,u8 data)
{
mapper->Write(addr,data);
}

void MapperCycle(int pixel)
{
mapper->Cycle(pixel);
}

int MapperSupported(int m)
{
switch(m)
	{
	case 0:
	case 1:
	case 2:
	case 3:
	case 4:
	case 7:
	case 9:
	case 15:
	case 19:
	case 34:
	case 40:
	case 41:
	case 42:
	case 44:
	case 45:
	case 47:
	case 50:
	case 61:
	case 66:
	case 71:
	case 79:
	case 105:
	case 113:
	case 232:
	case 234:
		return(0);
	}
return(1);
}

int MapperInit(int m)
{
if(mapper)
	delete mapper;
mapper = 0;
nes.ppu->cycle = 0;
switch(m)
	{
	default:
		if(nes.rom)			free(nes.rom);
		if(nes.chrrom)		free(nes.chrrom);
		nes.rom = nes.chrrom = 0;
		message("unsupported mapper %d\n",m);
		return(1);
	case 0:mapper = new CMapper0();break;
	case 1:mapper = new CMapper1();break;
	case 2:mapper = new CMapper2();break;
	case 3:mapper = new CMapper3();break;
	case 4:mapper = new CMapper4();break;
	case 7:mapper = new CMapper7();break;
	case 9:mapper = new CMapper9();break;
	case 15:mapper = new CMapper15();break;
	case 19:mapper = new CMapper19();break;
	case 34:mapper = new CMapper34();break;
	case 40:mapper = new CMapper40();break;
	case 41:mapper = new CMapper41();break;
	case 42:mapper = new CMapper42();break;
	case 44:mapper = new CMapper44();break;
	case 45:mapper = new CMapper45();break;
	case 47:mapper = new CMapper47();break;
	case 50:mapper = new CMapper50();break;
	case 61:mapper = new CMapper61();break;
	case 66:mapper = new CMapper66();break;
	case 71:mapper = new CMapper71();break;
	case 79:mapper = new CMapper79();break;
	case 105:mapper = new CMapper105();break;
	case 113:mapper = new CMapper113();break;
	case 232:mapper = new CMapper232();break;
	case 234:mapper = new CMapper234();break;
	}
mapper->Reset();
return(0);
}
