#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "main.h"

u32 pc = 0;
u8 *memsrc;
int memsize;
static int src = 0;

static char *getbase(char *str,int *base)
{
*base = 10;
if(*str == '$')
	{
	str++;
	*base = 16;
	}
else if(*str == '0' && ((*(str+1) == 'x') || (*(str+1) == 'X')))
	{
	str += 2;
	*base = 16;
	}
return(str);
}

static void refresh(HWND dlg)
{
#define LINES 24
char str[128];
int i,j;
u8 b[8];
u32 p = pc;

SendDlgItemMessage(dlg,IDC_MEMORY,LB_RESETCONTENT,0,0);
for(i=0;i<LINES;i++)
	{
	for(j=0;j<8;j++)
		{
		if(src == 0)
			b[j] = nes.cpu->MemRead(p + j);
		else if(src == 1)
			b[j] = nes.ppu->MemRead(p + j);
		}
	sprintf(str,"%04X:\t$%02X $%02X $%02X $%02X-$%02X $%02X $%02X $%02X",p,b[0],b[1],b[2],b[3],b[4],b[5],b[6],b[7]);
	SendDlgItemMessage(dlg,IDC_MEMORY,LB_ADDSTRING,0,(LPARAM)(LPCTSTR)str);
	p += 8;
	}
}

static int CALLBACK memorydlgproc(HWND dlgwnd,UINT imsg,WPARAM wparam,LPARAM lparam)
{
char str[128];

switch(imsg)
	{
	case WM_INITDIALOG:
		SetDlgItemText(dlgwnd,IDC_ADDREDIT,"$0000");
		memsrc = nes.ram;
		memsize = 0x800;
		refresh(dlgwnd);
		return(1);
	case WM_COMMAND:
		switch(LOWORD(wparam))
			{
			case IDC_UP:
				if((pc - 8) >= 0)
					pc -= 8;
				refresh(dlgwnd);
				return(1);
			case IDC_DOWN:
				pc += 8;
				refresh(dlgwnd);
				return(1);
			case IDC_JUMP:
				GetDlgItemText(dlgwnd,IDC_ADDREDIT,str,128);
				if(strcmp(str,"") != 0)
					{
					char *stop,*p = str;
					int base = 10;

					p = getbase(p,&base);
					pc = (u16)strtol(p,&stop,base) & ~7;
					refresh(dlgwnd);
					}
				return(1);
			case IDC_RAMBTN:
				src = 0;
				refresh(dlgwnd);
				return(1);
			case IDC_VRAMBTN:
				src = 1;
				refresh(dlgwnd);
				return(1);
			case IDC_REFRESH:
				refresh(dlgwnd);
				return(1);
			case IDOK:
			case IDCANCEL:
				EndDialog(dlgwnd,0);
				return(1);
			}
		break;
	}
return(0);
} 
HWND memorydlgwnd = 0;
void memorydlg(HINSTANCE hinstance,HWND hwnd)
{
if((memorydlgwnd = CreateDialog(hinstance,MAKEINTRESOURCE(IDD_MEMORYDLG),hwnd,memorydlgproc)) == 0)
	{
	message("cant create memory dialog\n");
	return;
	}
UpdateWindow(memorydlgwnd);
ShowWindow(memorydlgwnd,SW_SHOW);
}
