/*
** Nofrendo (c) 1998-2000 Matthew Conte (matt@conte.com)
**
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of version 2 of the GNU Library General 
** Public License as published by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful, 
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
** Library General Public License for more details.  To obtain a 
** copy of the GNU Library General Public License, write to the Free 
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
** Any permitted reproduction of these routines, in whole or in part,
** must bear this legend.
**
**
** types.h
**
** Data type definitions
** $Id: mtypes.h,v 1.1.1.1 2007/11/07 08:47:04 holodnak Exp $
*/

#ifndef _MTYPES_H_
#define _MTYPES_H_

/* Define this if running on little-endian (x86) systems */
#define  HOST_LITTLE_ENDIAN

/* These should be changed depending on the platform */
typedef  char     int8;
typedef  short    int16;
typedef  int      int32;

typedef  unsigned char  uint8;
typedef  unsigned short uint16;
typedef  unsigned long   uint32; //changed from "unsigned int"

typedef  uint8    boolean;

#ifndef  TRUE
#define  TRUE     1
#endif
#ifndef  FALSE
#define  FALSE    0
#endif
#ifndef INLINE
#define INLINE __inline
#endif
#ifndef ASSERT
#define ASSERT
#endif
#define ASSERT_MSG

#endif /* _TYPES_H_ */

/*
** $Log: mtypes.h,v $
** Revision 1.1.1.1  2007/11/07 08:47:04  holodnak
** initial import into cvs
**
** Revision 1.3  2007/11/07 08:36:27  holodnak
** no changes
**
** Revision 1.2  2007/11/07 02:00:30  holodnak
** fixed many silly errors
**
** Revision 1.1.1.1  2007/09/19 22:07:51  holodnak
** no message
**
** Revision 1.6  2000/06/09 15:12:25  matt
** initial revision
**
*/