#ifndef nesH
#define nesH

#include "cpu.h"

class Cnes
	{
	public:
		u8 *rom,*chrrom;
		int prgsize,chrsize;
		u8 header[16];
		u8 ram[0x800];
		u8 vram[0x4000];
		u8 sram[0x4000];
		u32 mask;
		Ccpu *cpu;				//active cpu for this nes
		Cppu *ppu;				//active ppu
		Capu *apu;				//active apu
	public:
	   Cnes();
		int LoadROM(char *filename);
		__inline void Step();
		void Execute(int n);
		void Frame();
		void Reset();
		int SaveState(char *fn);
		int LoadState(char *fn);
		void SetSizeSRAM(int s);
		void SetSizeVRAM(int s);
		void SetPageCPU8(int p,int d);
		void SetPageCPU16(int p,int d);
		void SetPageCPU32(int p,int d);
		void SetPagePPU1(int p,int d);
		void SetPagePPU4(int p,int d);
		void SetPagePPU8(int p,int d);
		void SetPageVRAM1(int p,int d);
		void SetPageVRAM4(int p,int d);
		void SetPageVRAM8(int p,int d);
   };

#endif
