#ifndef __romdb_h__
#define __romdb_h__

#include "types.h"

class CROM
	{
	public:
		u32 crc32;
		u32 prgbanks;
		u32 chrbanks;
		u32 mapper;
		u32 flags;
		char name[1024];
		CROM *next;
	public:
		CROM(){next=0;}
		CROM(u32 crc,u32 m,u32 f,char *n)
			{
			SetCRC32(crc);
			SetPRGBanks(0);
			SetCHRBanks(0);
			SetMapper(m);
			SetFlags(f);
			SetName(n);
			SetNext(0);
			}
		CROM(u32 crc,u32 p,u32 c,u32 m,u32 f,char *n)
			{
			SetCRC32(crc);
			SetPRGBanks(p);
			SetCHRBanks(c);
			SetMapper(m);
			SetFlags(f);
			SetName(n);
			SetNext(0);
			}
		void SetCRC32(u32 n){crc32=n;}
		void SetPRGBanks(u32 n){prgbanks=n;}
		void SetCHRBanks(u32 n){chrbanks=n;}
		void SetMapper(u32 n){mapper=n;}
		void SetFlags(u32 n){flags=n;}
		void SetName(char *n){strncpy(name,n,1024);}
		void SetNext(CROM *n){next=n;}
	};

class CROMDB
	{
	protected:
		CROM head;
	public:
		CROMDB();
		int Create();							//create new rom db
		void Destroy();						//free all data
		int Load(char *fn);					//load rom db from file
		int Save(char *fn);					//save rom db to file
		int Add(u32 crc32,char *name,u32 mapper,u32 flags);	//add rom to database
		int Delete(u32 crc32);				//remove rom from database
		int GetNum();							//returns number of entries in rom db
	};

#endif
