#include <windows.h>
#include <stdio.h>
#include "window.h"
#include "main.h"
#include "resource.h"
#include "memorydlg.h"
#include "debuggerdlg.h"
#include "aboutdlg.h"
#include "video.h"
#include "romsdlg.h"
/************************************************************************************************/
HINSTANCE hinstance;
HWND hWnd;
static int w,h;
/************************************************************************************************/
static void pause(int safe)
{
}
/************************************************************************************************/
static void resume(int safe)
{
}
/************************************************************************************************/
char filename[MAX_PATH] = "";
char filefilter[] = "nes rom files (*.nes)\0*.nes\0unif rom files (*.unf;*.unif)\0*.unf;*.unif\0individual files (*.prg)\0*.prg\0all files (*.*)\0*.*\0";
int filedialog(HWND parent,int type,char *buffer,char *title,char *filter,char *curdir)
{
OPENFILENAME dlgdata;

dlgdata.lStructSize = sizeof(OPENFILENAME);
dlgdata.hwndOwner = parent;
dlgdata.hInstance = 0;
dlgdata.lpstrFilter = filter;
dlgdata.lpstrCustomFilter = 0;
dlgdata.nMaxCustFilter = 0;
dlgdata.nFilterIndex = 0;
dlgdata.lpstrFile = buffer;
dlgdata.nMaxFile = 512;
dlgdata.lpstrFileTitle = 0;
dlgdata.nMaxFileTitle = 0;
dlgdata.lpstrInitialDir = curdir;
dlgdata.lpstrTitle = title;
dlgdata.Flags = OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY;
dlgdata.nFileOffset = 0;
dlgdata.nFileExtension = 0;
dlgdata.lpstrDefExt = 0;
dlgdata.lCustData = 0;
dlgdata.lpfnHook = 0;
dlgdata.lpTemplateName = 0;
switch(type)
	{
	default:
	case 0: //open
		if(GetOpenFileName(&dlgdata) != 0)
			{
			return(0);
			}
		break;
	case 1: //save
		if(GetSaveFileName(&dlgdata) != 0)
			return(0);
		break;
	}
return(1);
}
static LRESULT CALLBACK wndproc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam)
{
char filefilter[] = "nes rom files (*.nes)\0*.nes\0unif rom files (*.unf;*.unif)\0*.unf;*.unif\0individual files (*.prg)\0*.prg\0all files (*.*)\0*.*\0";

switch(iMsg)
	{
	case WM_CLOSE:
	case WM_DESTROY:
	case WM_QUIT:
		quit = 1;
		return(0);
	case WM_MOVE:
	case WM_SIZE:
		if(video)
			video->Resize();
		return(0);
	case WM_KEYDOWN:
/*		switch(wParam)
			{
			case VK_F5:savestate();return(0);
			case VK_F8:loadstate();return(0);
			case VK_F9:return(0);
			case '0':setsaveslot(0);return(0);
			case '1':setsaveslot(1);return(0);
			case '2':setsaveslot(2);return(0);
			case '3':setsaveslot(3);return(0);
			case '4':setsaveslot(4);return(0);
			case '5':setsaveslot(5);return(0);
			case '6':setsaveslot(6);return(0);
			case '7':setsaveslot(7);return(0);
			case '8':setsaveslot(8);return(0);
			case '9':setsaveslot(9);return(0);
			}*/
		break;
/*	case WM_ENTERMENULOOP:
	case WM_ENTERSIZEMOVE:
	case WM_KILLFOCUS:if(settings.pausenotfocused)pause(1);return(0);
	case WM_EXITMENULOOP:
	case WM_EXITSIZEMOVE:
	case WM_SETFOCUS:if(settings.pausenotfocused)resume(1);return(0);*/
	case WM_SYSCOMMAND:
		switch(wParam)
			{
			case SC_SCREENSAVE:		//screensaver going to come on
				return(FALSE);			//prevent it, play the nintendo!
			}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam))
			{
			case FILE_OPEN:
				memset(filename,0,MAX_PATH);
				if(filedialog(hwnd,0,filename,"open nes rom",filefilter,"") == 0)
					{
					
					if(nes.LoadROM(filename) == 0)
						{
						char *pp = strrchr(filename,'\\');

						*pp = 0;
						strncpy(curdir,filename,260);
						nes.Reset();
						}
					message("rom loaded ok\n");
					}
				return(0);
			case VIEW_DEBUGGER:
				if(nes.prgsize)
					debuggerdlg(GetModuleHandle(0),hwnd);
				return(0);
			case FILE_EXIT:quit = 1;return(0);
			case EMU_RESET:nes.Reset();return(0);
			case EMU_START:running++;return(0);
			case EMU_STOP:running--;return(0);
			case HELP_ABOUT:
				aboutdlg(GetModuleHandle(0),hwnd);
				return(0);
			case VIEW_MEMORY:
				if(nes.prgsize)
					memorydlg(GetModuleHandle(0),hwnd);
				return(0);
			case FILE_OPENROMDIALOG:
			case VIEW_ROMDIALOG:romsdlg(GetModuleHandle(0),hwnd);return(0);
			}
		break;
	}
return(DefWindowProc(hwnd,iMsg,wParam,lParam));
}
/************************************************************************************************/
HWND createmainwindow(int width,int height)
{
WNDCLASS wndclass;
RECT rw,rc;

w = width;
h = height;
hinstance = GetModuleHandle(0);
wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
wndclass.lpfnWndProc   = wndproc;
wndclass.cbClsExtra    = 0;
wndclass.cbWndExtra    = 0;
wndclass.hInstance     = hinstance;
wndclass.hIcon         = LoadIcon(hinstance,MAKEINTRESOURCE(IDI_MAINICON));
wndclass.hCursor       = LoadCursor(0,IDC_ARROW);
wndclass.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
wndclass.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU);
wndclass.lpszClassName = "neswindowclass";
if(RegisterClass(&wndclass) == 0)
	{
	message("createmainwindow: error: cant register window class");
	return(0);
	}
if((hWnd = CreateWindowEx(WS_EX_CLIENTEDGE,wndclass.lpszClassName,"amphetamines",WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_SYSMENU|WS_THICKFRAME|WS_CAPTION|WS_OVERLAPPED,CW_USEDEFAULT,CW_USEDEFAULT,width,height,0,0,hinstance,0)) == 0)
	{
	UnregisterClass(wndclass.lpszClassName,hinstance);
	message("createmainwindow: error: cant create main window");
	return(0);
	}
GetWindowRect(hWnd,&rw);
GetClientRect(hWnd,&rc);
SetWindowPos(hWnd,0,0,0,((rw.right - rw.left) - rc.right) + width,((rw.bottom - rw.top) - rc.bottom) + height,SWP_NOZORDER | SWP_NOMOVE);
ShowWindow(hWnd,SW_SHOWDEFAULT);
UpdateWindow(hWnd);
return(hWnd);
}
/************************************************************************************************/
void destroymainwindow()
{
RECT rect;

GetWindowRect(hWnd,&rect);
DestroyWindow(hWnd);
UnregisterClass("nes",GetModuleHandle(0));
}
/************************************************************************************************/
